﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition

Namespace CustomTrackPolygon

    Public Class CustomTrackInteractiveOverlay
        Inherits TrackInteractiveOverlay

        Const minVertexNum As Integer = 2

        Public Event VertexRemoved As EventHandler(Of VertexAddedTrackInteractiveOverlayEventArgs)

        Public Sub New()
            MyBase.New()
            Me.TrackMode = TrackMode.Polygon
        End Sub

        Public ReadOnly Property CurrentVerticeNumber As Integer
            Get
                Return Me.Vertices.Count - 1
            End Get
        End Property

        Protected Overridable Sub OnVertexRemoved(e As VertexAddedTrackInteractiveOverlayEventArgs)
            'Dim handler As EventHandler(Of VertexAddedTrackInteractiveOverlayEventArgs) = VertexRemoved

            'RaiseEvent handler(Me, e)
            RaiseEvent VertexRemoved(Me, e)
        End Sub

        Protected Overrides Function MouseDownCore(interactionArguments As InteractionArguments) As InteractiveResult
            System.Diagnostics.Debug.WriteLine(Me.Vertices.Count)

            If interactionArguments.MouseButton <> MapMouseButton.Right Then
                Return MyBase.MouseDownCore(interactionArguments)
            Else
                If Me.Vertices.Count >= 5 Then
                    RemoveLastVertexAdded()
                    MouseDownCount = MouseDownCount - 1
                End If

                Return New InteractiveResult()
            End If
        End Function

        Private Sub RemoveLastVertexAdded()
            If Me.Vertices.Count > minVertexNum Then
                Me.Lock.EnterWriteLock()
                Try
                    Dim lastVertex As Vertex = Me.Vertices(Me.Vertices.Count - 2)
                    Me.Vertices.Remove(lastVertex)
                    OnVertexRemoved(New VertexAddedTrackInteractiveOverlayEventArgs(lastVertex, Me.TrackShapeLayer.InternalFeatures(0)))
                Finally
                    Me.Lock.ExitWriteLock()
                End Try
            End If
        End Sub

    End Class
End Namespace
