﻿Imports System
Imports System.Windows.Forms
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports CustomTrackPolygonVB.CustomTrackPolygon

Public Class TestForm

    'Private vertexCount As Integer
    Private customTrackInteractiveOverlay As CustomTrackInteractiveOverlay

    Private Sub TestForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        customTrackInteractiveOverlay = New CustomTrackInteractiveOverlay()

        AddHandler customTrackInteractiveOverlay.VertexAdded, AddressOf winformsMap1_VertexAdded
        AddHandler customTrackInteractiveOverlay.VertexRemoved, AddressOf winformMap1_VertexRemoved
        customTrackInteractiveOverlay.TrackMode = TrackMode.Line

        Label1.Text = "Left click to track polygon. Right click to remove last vertex."

        winformsMap1.TrackOverlay = customTrackInteractiveOverlay

        winformsMap1.MapUnit = GeographyUnit.DecimalDegree
        winformsMap1.CurrentExtent = New RectangleShape(-95.2957, 38.9791, -95.2397, 38.9452)
        winformsMap1.BackgroundOverlay.BackgroundBrush = New GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255))

        'Displays the World Map Kit as a background.
        Dim worldMapKitDesktopOverlay As New ThinkGeo.MapSuite.DesktopEdition.WorldMapKitWmsDesktopOverlay()
        winformsMap1.Overlays.Add(worldMapKitDesktopOverlay)

        winformsMap1.Refresh()
    End Sub

    Private Sub winformsMap1_MouseMove(sender As Object, e As MouseEventArgs) Handles winformsMap1.MouseMove
        'Displays the X and Y in screen coordinates.
        statusStrip1.Items("toolStripStatusLabelScreen").Text = "X:" + e.X.ToString() + " Y:" + e.Y.ToString()

        'Gets the PointShape in world coordinates from screen coordinates.
        Dim pointShape As PointShape = ExtentHelper.ToWorldCoordinate(winformsMap1.CurrentExtent, New ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height)

        'Displays world coordinates.
        statusStrip1.Items("toolStripStatusLabelWorld").Text = "(world) X:" + Math.Round(pointShape.X, 4).ToString() _
                        + " Y:" + Math.Round(pointShape.Y, 4).ToString()
    End Sub

    Private Sub winformsMap1_VertexAdded(sender As Object, e As VertexAddedTrackInteractiveOverlayEventArgs)
        If Not IsDBNull(customTrackInteractiveOverlay) Then
            'vertexCount = vertexCount + 1

            ' This event is fired four times when the first vertex of the polygon is added, therefore subtract
            ' out three to get the correct number of vertices.
            Label2.Text = "Total Number of Vertices:  " + (customTrackInteractiveOverlay.CurrentVerticeNumber).ToString()
        End If
    End Sub

    Private Sub winformMap1_VertexRemoved(sender As Object, e As VertexAddedTrackInteractiveOverlayEventArgs)
        'vertexCount = vertexCount - 1

        ' This event is fired four times when the first vertex of the polygon is added, therefore subtract
        ' out three to get the correct number of vertices.
        Label2.Text = "Total Number of Vertices:  " + (customTrackInteractiveOverlay.CurrentVerticeNumber).ToString()
    End Sub

    Private Sub btnClose_Click(sender As Object, e As EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

End Class